/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.builders.client.render;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BufferBuilder;

import net.minecraftforge.client.model.animation.FastTESR;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import buildcraft.lib.client.render.laser.LaserBoxRenderer;

import buildcraft.builders.tile.TileFiller;
import buildcraft.core.client.BuildCraftLaserManager;

@SideOnly(Side.CLIENT)
public class RenderFiller extends FastTESR<TileFiller> {

    @Override
    public void renderTileEntityFast(TileFiller tile, double x, double y, double z, float partialTicks,
        int destroyStage, float partial, BufferBuilder bb) {
        Minecraft.func_71410_x().field_71424_I.func_76320_a("bc");
        Minecraft.func_71410_x().field_71424_I.func_76320_a("filler");

        Minecraft.func_71410_x().field_71424_I.func_76320_a("main");
        if (tile.getBuilder() != null) {
            RenderSnapshotBuilder.render(tile.getBuilder(), tile.func_145831_w(), tile.func_174877_v(), x, y, z, partialTicks, bb);
        }
        Minecraft.func_71410_x().field_71424_I.func_76319_b();

        Minecraft.func_71410_x().field_71424_I.func_76320_a("box");
        if (tile.markerBox) {
            bb.func_178969_c(x - tile.func_174877_v().func_177958_n(), y - tile.func_174877_v().func_177956_o(), z - tile.func_174877_v().func_177952_p());
            LaserBoxRenderer.renderLaserBoxDynamic(tile.box, BuildCraftLaserManager.STRIPES_WRITE, bb, true);
            bb.func_178969_c(0, 0, 0);
        }
        Minecraft.func_71410_x().field_71424_I.func_76319_b();

        Minecraft.func_71410_x().field_71424_I.func_76319_b();
        Minecraft.func_71410_x().field_71424_I.func_76319_b();
    }

    @Override
    public boolean func_188185_a(TileFiller te) {
        return true;
    }
}
